<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/common/code_utils.hpp File Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('da/d7b/code__utils_8hpp.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a>  </div>
  <div class="headertitle">
<div class="title">code_utils.hpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This file includes macros for validating runtime conditions.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &lt;stdbool.h&gt;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for code_utils.hpp:</div>
<div class="dyncontent">
<div class="center"><img src="../../df/df0/code__utils_8hpp__incl.png" border="0" usemap="#src_2core_2common_2code__utils_8hpp" alt=""/></div>
<map name="src_2core_2common_2code__utils_8hpp" id="src_2core_2common_2code__utils_8hpp">
<area shape="rect" id="node2" href="../../d9/d5e/stdbool_8h_source.html" title="stdbool.h" alt="" coords="46,92,121,117"/>
</map>
</div>
</div>
<p><a href="../../da/d7b/code__utils_8hpp_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a40b7761d086af70d4dd8c1178d71d548"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a40b7761d086af70d4dd8c1178d71d548"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>otALIGNED_VAR_SIZE</b>(size,  align_type)                    &#160;&#160;&#160;(((size) + (sizeof (align_type) - 1)) / sizeof (align_type))</td></tr>
<tr class="separator:a40b7761d086af70d4dd8c1178d71d548"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab523f093c16ab3e7dd1fb1bac04feb4f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab523f093c16ab3e7dd1fb1bac04feb4f"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>otDEFINE_ALIGNED_VAR</b>(name,  size,  align_type)                    &#160;&#160;&#160;align_type name[(((size) + (sizeof (align_type) - 1)) / sizeof (align_type))]</td></tr>
<tr class="separator:ab523f093c16ab3e7dd1fb1bac04feb4f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ace2ffeb7c62da00816e9f06dc5f843f2"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><b>SuccessOrExit</b>(ERR)                                        </td></tr>
<tr class="separator:ace2ffeb7c62da00816e9f06dc5f843f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a97b07c5b705a40172de195f6bf1cbea1"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><b>VerifyOrExit</b>(COND,  ACTION)</td></tr>
<tr class="separator:a97b07c5b705a40172de195f6bf1cbea1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a639675aa4ed35064b2ad6fb8271e41da"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><b>ExitNow</b>(...)                                                    </td></tr>
<tr class="separator:a639675aa4ed35064b2ad6fb8271e41da"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This file includes macros for validating runtime conditions. </p>
</div><h2 class="groupheader">Macro Definition Documentation</h2>
<a class="anchor" id="a639675aa4ed35064b2ad6fb8271e41da"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define ExitNow</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>...</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><span class="keywordflow">do</span> {                                          \</div><div class="line">    __VA_ARGS__;                                \</div><div class="line">    goto exit;                                  \</div><div class="line">  } <span class="keywordflow">while</span> (<span class="keyword">false</span>)</div></div><!-- fragment -->
</div>
</div>
<a class="anchor" id="ace2ffeb7c62da00816e9f06dc5f843f2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SuccessOrExit</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">ERR</td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><span class="keywordflow">do</span> {                                          \</div><div class="line">    if ((ERR) != 0) {                           \</div><div class="line">      goto exit;                                \</div><div class="line">    }                                           \</div><div class="line">  } <span class="keywordflow">while</span> (<span class="keyword">false</span>)</div></div><!-- fragment -->
</div>
</div>
<a class="anchor" id="a97b07c5b705a40172de195f6bf1cbea1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define VerifyOrExit</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">COND, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">ACTION&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><span class="keywordflow">do</span> {                             \</div><div class="line">    if (!(COND)) {                 \</div><div class="line">      ACTION;                      \</div><div class="line">      goto exit;                   \</div><div class="line">    }                              \</div><div class="line">  } <span class="keywordflow">while</span> (<span class="keyword">false</span>)</div></div><!-- fragment -->
</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_34b4cee2b5900b653deb3438fc906cf4.html">common</a></li><li class="navelem"><a class="el" href="../../da/d7b/code__utils_8hpp.html">code_utils.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:34 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
